/* colorprint.h
	functions for formating things nicely
*/

/* outputs stuff like emacs' hexl-mode */
#ifndef _FOO_H_
extern void hexlprint(unsigned char *data, int datalen);
#endif

/*	print things in different colors
	Use like:
	RED printf("Foo!") NORMAL;
*/
#ifdef COLOR
#define NORMAL  ;printf("\033[0m\n")

#define BLACK   printf("\033[30m");
#define RED     printf("\033[31m");
#define GREEN   printf("\033[32m");
#define BROWN   printf("\033[33m");
#define BLUE    printf("\033[34m");
#define PURPLE  printf("\033[35m");
#define CYAN    printf("\033[36m");
#define GRAY    printf("\033[37m");
#define WHITE   printf("\033[38m");

#define BLACKB  printf("\033[40m");
#define REDB    printf("\033[41m");
#define GREENB  printf("\033[42m");
#define BROWNB  printf("\033[43m");
#define BLUEB   printf("\033[44m");
#define PURPLEB printf("\033[45m");
#define CYANB   printf("\033[46m");
#define GRAYB   printf("\033[47m");
#define WHITEB  printf("\033[48m");

#else
#define NORMAL  ;printf("\n");

#define BLACK
#define RED
#define GREEN
#define BROWN
#define BLUE
#define PURPLE
#define CYAN
#define GRAY
#define WHITE

#define BLACKB
#define REDB
#define GREENB
#define BROWNB
#define BLUEB
#define PURPLEB
#define CYANB
#define GRAYB
#define WHITEB
#endif

/* Style macros - use like the color ones above */
#define WARN  printf(" "); RED
#define HEAD  WHITE
#define OK    printf(" "); GREEN
#define TEXT  printf(" "); GRAY

/* if cond then print value in green, otherwise print in red and append warn
 * TESTPRINTd = value is a signed int
 * TESTPRINTu = value is an unsigned int
 * TESTPRINTs prints s1 in green if conde or s2 in red if not
 */
#define TESTPRINTd(cond,value,warn) \
      if(cond) {OK printf("%d",value);}\
      else {WARN printf("%d (%s)",value,warn);}

#define TESTPRINTu(cond,value,warn) \
      if(cond) {OK printf("%u",value);}\
      else {WARN printf("%u (%s)",value,warn);}

#define TESTPRINTs(cond,s1,s2) \
      if(cond) {OK printf(s1);}\
      else {WARN printf(s2);}

/* print out checksum, checking if it is correct first */
#define PRINTCSUM(c2,c1) \
      if(c1 == c2) {OK printf("%04X",c1);}\
      else {WARN printf("%04X (should be %04X)",c2,c1);}
